/**********************************************************************************************************************************
Data Visualization Task-Midterm Project             
Tested in Processing 3.5.4                                    
                                                     
Author: Yulei Yuan                                               

Purpose: Show the checkout numbers of medias with titles contained "moon", "earth" and "sun" for all dewey classes.  
Reference: The interaction code referred from the China-Japan Example by Li Zheng.   

Usage: 1.Press 'e' to remove earth curve
       2.Press 'm' to remove moon curve
       3.Press 's' to remove sun curve
       4.Press 'up' and 'down' to control earth curve
       5.Press 'left' and 'right' to control sun curve
       6.Press 'q' and 'a' to control moon curve
**********************************************************************************************************************************/
import peasy.*;
import peasy.org.apache.commons.math.*;
import peasy.org.apache.commons.math.geometry.*;
import controlP5.*; //GUI library


boolean presentationMode = false; 
                                 
ControlP5 cp5; //User Interface 
Textarea myTextarea; 
Textarea myTextarea2; 

//set colors for the lines
int EarthR = 0;
int EarthG = 135;
int EarthB = 245;
int EarthTrans =  100;
int SunR = 255;
int SunG = 70;
int SunB = 70;
int SunTrans = 100;
int MoonR = 255;
int MoonG = 208;
int MoonB = 0;
int MoonTrans = 100;
int totalYear = 14;
int beginDewey = 50; 
int endDewey = 99;
int cVolume[][] = new int[totalYear][100];
int jVolume[][] = new int[totalYear][100];
int mVolume[][] = new int[totalYear][100];
int EarthHeight = 10; 
int SunHeight = 10; 
int MoonHeight = 10;
float zBase = 10; 
int X = 600; 
int Y = 500; 
int Z = 5000; 

color cColor = color(EarthR, EarthG, EarthB, EarthTrans);
color jColor = color(SunR, SunG, SunB, SunTrans); 
color mColor = color(MoonR, MoonG, MoonB, MoonTrans); 



// Download and data from csv files
String cFile = "earthdata.csv";
String jFile = "sundata.csv";
String mFile = "moondata.csv";
String[] class_names = {"Earth", "Sun","Moon"};


String cString[], jString[],mString[];

PeasyCam cam; 

float adjustX = float(X)/(endDewey-beginDewey);
float adjustY = float((Y-10))/(totalYear-1);


void setup() {
  size(1280, 720, P3D);
  smooth();
  
  cam = new PeasyCam(this, X/2, Y/2, 100, 1800);
  cp5 = new ControlP5(this);
    
  cp5.addCheckBox("checkBox")
     .setPosition(1040, 20)
     .setSize(15, 15) 
     .addItem("Double click to return to original position", 1)
     .setColorForeground(color(120))
      .setColorActive(color(#0CA4E8))
         .setColorLabel(color(0))
     ;  
     
  cp5.setAutoDraw(false);
  
  //  myTextarea = cp5.addTextarea("txt")
  //                .setFont(createFont("arial",11))
  //                .setPosition(20,50)
  //                .setSize(250,180)
  //                .setLineHeight(14)
  //                .setColor(color(0))
  //                .setColorBackground(color(255,100))
  //                .setColorForeground(color(255,100));
               
  //                ;
  //myTextarea.setText("\n" + " Earth, Moon and Sun in Literature"
  //                  + "\n" + "\n" + "The checkout numbers of medias with titles containing earth, moon and sun are presented on this graph" +
  //                  "for all dewey classes from 2006 to 2019" +"\n" + "\n"+"The original dataset was modified for presentational purpose"
  //                  );
  //myTextarea2 =  cp5.addTextarea("Layer")
  //                //.setFont(createFont("arial",11))
  //                .setPosition(1000,600)
  //                .setSize(250,180)
                  //.setLineHeight(14)
                  //.setColor(color(0))
                  //.setColorBackground(color(100,100))
                  //.setColorForeground(color(100,100));
                  //;
  //myTextarea2.setText("Layers(1 to 21):"
  //                  + "\n" +"Population Type:"+ "\n" + "Men"+ "\n" + "White" + "\n" + "Citizen"+ "\n"+"Minority"+"\n" + "\n" +"Wealth:"+ 
  //                  "\n" );
  cam.setMinimumDistance(1);//1
  cam.setMaximumDistance(Z);//was 5000, now 2000
  

  float fov = PI/8; // field of view try between PI/2 to PI/10
  float cameraZ = (height/2.0) / tan(PI/6);
  perspective(fov, float(width)/float(height), cameraZ/0.001, cameraZ*0.001); 
  
}
//----------------------------------------------------------
void draw() {
  background(230);
  rotateX(PI/6);
  initializeData();
  drawLabels(); 
  if (earth) {
  drawEarth();
  }
  if (sun){
  drawSun(); 
  }
  if (moon){
  drawMoonfunt();
  }
  drawLegend();
    //Set automation in presentation mode 
  if(presentationMode) {
    rotateY(PI/2);
  }

  cam.beginHUD();  //Stopping peasy cam
  fill(150);
  //rect(0, 0, width, 35);
  fill(255);
  textAlign(RIGHT);
  cp5.draw();
  cam.endHUD();
    if (keyPressed) {
      if (key == CODED && keyCode == UP && EarthHeight < 200) {
        EarthHeight+=1;
      } else if (key == CODED && keyCode == DOWN && EarthHeight >0) {
        EarthHeight-=1;
      }
      if (key == CODED && keyCode == RIGHT && SunHeight < 200) {
        SunHeight+=1;
      } else if (key == CODED && keyCode == LEFT && SunHeight >0) {
        SunHeight-=1;
      }
      if (key == 'q' && MoonHeight < 20) {
        MoonHeight+=1;
      } else if (key == 'a' && MoonHeight >0) {
        MoonHeight-=1;
      }
    }
}
