//----------------------------------------------------------
void drawEarth() {
  float z1, z2, z3, z4, x1, x2, y1, y2;

  cColor = color(EarthR, EarthG, EarthB, EarthTrans);
  fill(cColor);

  for (int i = beginDewey; i < endDewey; i++) {
    for (int j = 0; j < totalYear - 1; j++) {

      beginShape(POLYGON);
      z1 = min(cVolume[j][i], Z)+zBase;
      z2 = min(cVolume[j+1][i], Z)+zBase;
      z3 = min(cVolume[j+1][i+1], Z)+zBase;
      z4 = min(cVolume[j][i+1], Z)+zBase;

      x1 = (i-beginDewey)*adjustX;
      x2 = (i+1-beginDewey)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      curveVertex(x1, y1, z1);
      curveVertex(x1, y2, z2);
      curveVertex(x2, y2, z3);
      curveVertex(x2, y1, z4);
      endShape();
    }
  } 
}
//----------------------------------------------------------
void drawSun() {
  float z1, z2, z3, z4, x1, x2, y1, y2;

  jColor = color(SunR, SunG, SunB, SunTrans);
  fill(jColor);
  
  for (int i = beginDewey; i < endDewey; i++) {
    for (int j = 0; j < totalYear - 1; j++) {     
      beginShape(POLYGON);
      z1 = min(jVolume[j][i], Z)+zBase;
      z2 = min(jVolume[j+1][i], Z)+zBase;
      z3 = min(jVolume[j+1][i+1], Z)+zBase;
      z4 = min(jVolume[j][i+1], Z)+zBase;

      x1 = (i-beginDewey)*adjustX;
      x2 = (i+1-beginDewey)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      curveVertex(x1, y1, z1);
      curveVertex(x1, y2, z2);
      curveVertex(x2, y2, z3);
      curveVertex(x2, y1, z4);
      endShape();
    }
  }
}


void drawMoonfunt() {
  float z1, z2, z3, z4, x1, x2, y1, y2;

  mColor = color(MoonR, MoonG, MoonB, MoonTrans);
  fill(mColor);
  
  for (int i = beginDewey; i < endDewey; i++) {
    for (int j = 0; j < totalYear - 1; j++) {     
      beginShape(POLYGON);
      z1 = min(mVolume[j][i], Z)+zBase;
      z2 = min(mVolume[j+1][i], Z)+zBase;
      z3 = min(mVolume[j+1][i+1], Z)+zBase;
      z4 = min(mVolume[j][i+1], Z)+zBase;

      x1 = (i-beginDewey)*adjustX;
      x2 = (i+1-beginDewey)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      curveVertex(x1, y1, z1);
      curveVertex(x1, y2, z2);
      curveVertex(x2, y2, z3);
      curveVertex(x2, y1, z4);
      endShape();
    }
  }
}  

//----------------------------------------------------------
void drawLabels() {
  float adjustY = float((Y-10))/(totalYear);
  //draw Y
  for (int i = 0; i <= totalYear-1; i++) {
    fill(0);
    textSize(10);
    text(i+2006, -15, i*adjustY+30);
  }
  //draw X
  for (int i = beginDewey; i <= endDewey; i++) {
    textSize(10);
  }
  text("DeweyClasses",600, Y+20, 10);
}
